<template>
  <div class="flex justify-center items-center pt-6">
    <div class="w-full max-w-xs" v-if="showValidate == 0">
      <form
        class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4 max-w-md mx-auto"
      >
        <div class="mb-4">
          <label class="block mb-2" for="nombre">Nombre:</label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="text"
            id="nombre"
            placeholder="Name"
            v-model="formData.name"
            required
          />
        </div>

        <div class="mb-4">
          <label class="block mb-2" for="usuario">Usuario:</label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="text"
            id="usuario"
            placeholder="Username"
            v-model="formData.username"
            required
          />
        </div>

        <div class="mb-4">
          <label class="block mb-2" for="telefono">Teléfono:</label>
          <vue-country-code
            @onSelect="onSelect"
            :enableSearchField="true"
            :enabledCountryCode="true"
            :model="countrycode"
            :preferredCountries="['co', 'us']"
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
          >
          </vue-country-code>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="tel"
            id="telefono"
            placeholder="Phone Number"
            v-model="formData.phone"
            required
          />
        </div>

        <div class="mb-4">
          <label class="block mb-2" for="email">Email:</label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="email"
            id="email"
            placeholder="Email"
            v-model="formData.email"
            required
          />
        </div>

        <div class="mb-4">
          <label class="block mb-2" for="password">Contraseña:</label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="password"
            id="password"
            placeholder="Password"
            v-model="formData.password"
            required
          />
        </div>

        <div
          v-show="errorRegister"
          class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 mt-5 mb-5 rounded relative"
          role="alert"
        >
          <strong class="font-bold">Error! </strong>
          <ul>
            <li v-for="error in msjErrorRegister" :key="error">{{ error }}</li>
          </ul>
        </div>

        <button
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
          type="button"
          @click.prevent="validatePhone"
        >
          Registrarse
        </button>
      </form>
      <p class="text-center text-gray-500 text-xs">
        &copy; 2023 Genaro Muñoz obregón. Para Nu image.
      </p>
    </div>
    <div class="w-full max-w-xs" v-if="showValidate == 1">
      <form
        class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4 max-w-md mx-auto"
      >
        <h1 class="text-xl mb-4">Validación OTP</h1>
        <div class="mb-4">
          <label class="block mb-2" for="nombre">Código:</label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="text"
            id="codephone"
            placeholder="Code Phone"
            v-model="codephone"
            required
          />
        </div>

        <div class="mb-4">
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            type="hidden"
            id="otp_id"
            v-model="otp_id"
            required
          />
        </div>
        <button
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
          type="button"
          @click="validateCode"
        >
          Validar
        </button>
      </form>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Swal from "sweetalert2";

export default {
  data() {
    return {
      formData: {
        name: "",
        email: "",
        phone: "",
        username: "",
        password: "",
      },
      otp_id: "",
      codephone: "",
      showValidate: 0,
      countrycode: "",
      errorRegister: 0,
      msjErrorRegister: [],
    };
  },
  async created() {
    //await this.validateCode();
  },
  methods: {
    onSelect({ name, iso2, dialCode }) {
      this.countrycode = dialCode;
    },
    validateCode() {
      axios
        .post(process.env.VUE_APP_API_URL + "v1/otp/validate", {
          code: this.codephone,
          otp: this.otp_id,
        })
        .then((res) => {
          console.log(res.data);
          if (res.data.data.status == "APPROVED") {
            this.register();
          } else {
            this.showValidate = 0;
            this.formData.name = "";
            this.formData.phone = "";
            this.formData.email = "";
            this.formData.password = "";
            this.formData.username = "";
            Swal.fire({
              icon: "error",
              title: "Error de validación",
              text: "El codigo ingresado ya expiro o no es correcto, por favor intenta de nuevo",
            });
          }
        });
    },
    validatePhone() {
      if (this.validateForm()) {
        return;
      }

      const phonenum = "+" + this.countrycode + "" + this.formData.phone;
      axios
        .post(process.env.VUE_APP_API_URL + "v1/otp/generate", {
          codeco: this.countrycode,
          phonenumber: this.formData.phone,
        })
        .then((res) => {
          if (res.data.status == "Success") {
            this.showValidate = 1;
            this.otp_id = res.data.data.otp_id;
          }
        });
    },
    register() {
      axios
        .post(process.env.VUE_APP_API_URL + "v1/user/register", {
          name: this.formData.name,
          phone: this.formData.phone,
          email: this.formData.email,
          username: this.formData.username,
          password: this.formData.password,
        })
        .then((res) => {
          if (res.data.status == "Success") {
            this.formData.name = "";
            this.formData.phone = "";
            this.formData.email = "";
            this.formData.password = "";
            this.formData.username = "";

            Swal.fire({
              icon: "success",
              title: res.data.title,
              text: res.data.message,
              showCancelButton: true,
              confirmButtonText: "Ok",
            }).then((result) => {
              if (result.isConfirmed) {
                location.href = "/";
              }
            });
          } else {
            Swal.fire({
              icon: "error",
              title: "Something went wrong",
              text: "while saving or sending the message, try again later",
            });
          }
        });
    },

    validateForm() {
      this.errorRegister = 0;
      this.msjErrorRegister = [];

      if (this.formData.name == "") {
        this.msjErrorRegister.push("Nombre no puede ser vacio");
      }

      if (this.formData.username == "") {
        this.msjErrorRegister.push("Usuario no puede ser vacio");
      }

      if (this.formData.countrycode == "") {
        this.msjErrorRegister.push("Codigo pais no puede ser vacio");
      }

      if (this.formData.phone == "") {
        this.msjErrorRegister.push("Teléfono no puede ser vacio");
      }

      if (this.formData.email == "") {
        this.msjErrorRegister.push("Email no puede ser vacio");
      }

      if (this.formData.password == "") {
        this.msjErrorRegister.push("Password no puede ser vacio");
      }

      if (this.msjErrorRegister.length) this.errorRegister = 1;

      return this.errorRegister;
    },
    mounted() {
      console.log("Hi");
    },
  },
};
</script>
